package edu.toronto.cs.proof;


import java.util.*;

import edu.toronto.cs.mvset.*;
import edu.toronto.cs.modelchecker.*;
import edu.toronto.cs.ctl.*;
import edu.toronto.cs.algebra.*;

public class EGProofStep extends ProofStep 
{
  protected EGProofStep(AlgebraValue _v,
			MvSet _state,
			String _stateName,
			CTLNode _consequent)
  {
    super(_v, _state, _stateName, _consequent);
  }

  public boolean unfold()
  {
    CTLNode ctlr = consequent.getRight ();
    CTLMvSetNode s = CTLFactory.createCTLMvSetNode (state);
    s.setName (ProofStepFactory.makeStateName (state));
    //CTLMvSetNode nots = CTLFactory.createCTLMvSetNode (state.not());
    CTLNode nots = s.neg ();

    CTLNode exp = 
      ctlr.and (ctlr.eu (s).ex().or (ctlr.and (nots).eg ().ex ()));
    
    antecedents.add(ProofStepFactory.makeProofStep(v, state, exp));
    
    unfolded = true;
    return unfolded;
  }
  
  
  public Object accept (ProofVisitor pv, Object info)
  {
    return pv.visitEGStep(this,  info);
  }


}
